<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EquipamentoService;
use FM\Traits\TResponse;

class EquipamentoController {
    use TResponse;

    protected $dataSourceName = 'fcm_checklistagend';
    protected $EquipamentoService;
   
    public function __construct(EquipamentoService $EquipamentoService) {
        $this->EquipamentoService = $EquipamentoService;
    }

    public function getAtivos(Request $request) {
        try {
            $data = $this->EquipamentoService->getAtivos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarAtivo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->EquipamentoService->salvarAtivo($parametro);
        } catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteAtivos(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->EquipamentoService->deleteAtivos($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertFotosAtivo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->EquipamentoService->insertFotosAtivo($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosAtivo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $data = $this->EquipamentoService->getFotosAtivo($parametro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteFotoAtivo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $data = $this->EquipamentoService->deleteFotoAtivo($parametro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCategEquip(Request $request) {
        try {
            $data = $this->EquipamentoService->getCategEquip();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEscopos(Request $request) {
        try {
            $data = $this->EquipamentoService->getEscopos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>