<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ProdutoService;
use FM\Traits\TResponse;

class ProdutoController{
    use TResponse;

    protected $ProdutoService;
   
    public function __construct(ProdutoService $ProdutoService) {
        $this->ProdutoService = $ProdutoService;
    }
    
    public function produtos(Request $request) {
        try {
            $data = $this->ProdutoService->getProdutos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>