<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\TipoManutencaoService;
use FM\Traits\TResponse;

class TipoManutencaoController{
    use TResponse;
    protected $dataSourceName = 'fcm_checklistagend';
    protected $TipoManutencaoService;

    public function __construct(TipoManutencaoService $TipoManutencaoService) {
        $this->TipoManutencaoService = $TipoManutencaoService;
    }

    public function saveTipoManutencao(Request $request) {
        try {
            $params = $request->getParameters();
            $this->TipoManutencaoService->saveTipoManutencao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTiposManutencao(Request $request) {
        try {
            $data = $this->TipoManutencaoService->getTiposManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteTiposManutencao(Request $request) {
        try {
            $params = $request->getParameters();
            $this->TipoManutencaoService->deleteTiposManutencao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>