<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class TipoManutencaoFactory {
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function insertTipoManutencao($parametros) {

        $sql = "INSERT INTO FCM_TIPOMANUTENCAO (
                    NRTIPOMANUTENCAO,   NMTIPOMANUTENCAO,   NRORG,          IDATIVO,
                    DTINCLUSAO,         CDOPERINCLUSAO,     NRORGINCLUSAO,  DTULTATU,
                    CDOPERULTATU,       NRORGULTATU
                )
                VALUES (
                    :NRTIPOMANUTENCAO,  :NMTIPOMANUTENCAO,  :NRORG,         'S',
                    SYSDATE,            :CDOPERINCLUSAO,    :NRORGINCLUSAO, SYSDATE,
                    :CDOPERULTATU,      :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function editTipoManutencao($parametros) {
        $sql = "UPDATE FCM_TIPOMANUTENCAO
                SET NMTIPOMANUTENCAO    = :NMTIPOMANUTENCAO,
                    DTULTATU            = SYSDATE,
                    CDOPERULTATU        = :CDOPERULTATU,
                    NRORGULTATU         = :NRORGULTATU
                WHERE NRTIPOMANUTENCAO  = :NRTIPOMANUTENCAO";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getTiposManutencao() {

        $sql = "SELECT NRTIPOMANUTENCAO, NMTIPOMANUTENCAO
                    FROM FCM_TIPOMANUTENCAO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function deleteTiposManutencao($parametros) {
        $sql = "DELETE
                FROM FCM_TIPOMANUTENCAO
                WHERE NRTIPOMANUTENCAO IN (".$parametros.")";

        $this->connection->executeStatement($sql);
    }
}

?>